<!-- 
*************************************************
MassPayReceipt.cfm

This page takes necessary parameter from MassPay.cfm page 
and passing into doHttppost function which takes request value
as Struct Object it will call cfhttp tag to perform MassPay.This 
page will show the response value coming from the Server. If 
any error occurs, the page will redirect to APIError.cfm to 
show exact error details

*************************************************
-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<head>
    <title>PayPal SDK - MassPay Results</title>
    <link href="sdk.css" rel="stylesheet" type="text/css" />
</head>
<body>

<cfset StructClear(Session)>
<CFOBJECT COMPONENT="CallerService" NAME="caller">


<CFSET requestData = StructNew()>
<CFSET requestData.METHOD = "MassPay">
<CFSET requestData.USER = "#APIUserName#">
<CFSET requestData.PWD = "#APIPassword#">
<CFSET requestData.SIGNATURE = "#APISignature#">
<CFSET requestData.VERSION = "#version#">
<CFSET requestData.EMAILSUBJECT = "#Form.emailSubject#">
<CFSET requestData.RECEIVERTYPE = "#Form.receiverType#">
<CFSET requestData.CURRENCYCODE = "#Form.currency#">

<cfset receivermailArray = #ListToArray(receiveremail)#>
<cfset amtArray = #ListToArray(amount)#>
<cfset uidArray = #ListToArray(uniqueID)#>
<cfset noteArray = #ListToArray(note)#>
<cfset size = #ArrayLen(receivermailArray)#>

<!---
	If note is nulll, this method wil create empty noteArray 
--->
<cfinvoke component="CallerService" method="populateEmptyValue" returnvariable="note">
	<cfinvokeargument name="noteORuid" value=#noteArray#>
	<cfinvokeargument name="size" value=#size#>
</cfinvoke>
<cfset noteArray = #note#>

<!---
	If uniqueid  is nulll, this method wil create empty uniqueIdArray 
--->
<cfinvoke component="CallerService" method="populateEmptyValue" returnvariable="uid">
	<cfinvokeargument name="noteORuid" value=#uidArray#>
	<cfinvokeargument name="size" value=#size#>
</cfinvoke>
<cfset uidArray = "#uid#">

<cfloop index = "i" from = "1" to = #size#>

	<CFSET email = "L_EMAIL" & (i-1)>
	<CFSET amt = "L_Amt" & (i-1)>
	<CFSET uniqueid = "L_UNIQUEID" & (i-1)>
	<CFSET note = "L_NOTE" & (i-1)>

	<cfscript>

		StructInsert(requestData, email, receivermailArray[i]);
		StructInsert(requestData, amt, amtArray[i]);
		if(#ArrayLen(uidArray)# is not 0)
		StructInsert(requestData, uniqueid, uidArray[i]);
		if(#ArrayLen(noteArray)# is not 0)
		StructInsert(requestData, note, noteArray[i]);

	</cfscript>
</cfloop>

<CFTRY>

<!--- 
	Calling doHttppost for API call 
--->
<cfinvoke component="CallerService" method="doHttppost" returnvariable="response">

	<cfinvokeargument name="requestData" value=#requestData#>
	<cfinvokeargument name="serverURL" value=#serverURL#>
	<cfinvokeargument name="proxyName" value=#proxyName#>
	<cfinvokeargument name="proxyPort" value=#proxyPort#>
	<cfinvokeargument name="useProxy" value=#useProxy#>

</cfinvoke>

 <CFSET responseStruct = caller.getNVPResponse(#URLDecode(response)#)>
 <CFSET messages = ArrayNew(1)>
 <CFSET Session.resStruct ="#responseStruct#">
 <CFIF responseStruct.Ack is "Success">
    <center>
	<TABLE class="api" id="Table1">
		<TR>
			<TD class="header" colSpan="2"><STRONG>MassPay has been completed successfully!</STRONG>
			</TD>
		</TR>
	</TABLE>
    </center>
    </CFIF>
    <CFIF responseStruct.Ack is "Failure">
    <CFLOCATION URL="APIError.cfm?error=fromServer">
</CFIF>

<CFCATCH>
	<CFSET responseStruct = StructNew() >
	<CFSET responseStruct.errorType =  "#cfcatch.type#">
	<CFSET responseStruct.errorMessage =  "#cfcatch.message#">
	<CFSET Session.resStruct = "#responseStruct#">
	<CFLOCATION URL="APIError.cfm?error=fromClient">

</CFCATCH>
</CFTRY>  

   <a class="home" id="CallsLink" href="index.html">Home</a>
</body>
</html>