<!-- 
*************************************************
TransactionSearchResults.cfm

This page takes necessary parameter from TransactionSearch.cfm page 
and pssing into doHttppost function which takes request value
as Struct Object it will call cfhttp tag to perform TransactionSearch 
This page will show the response value coming from the Server. If 
any error occurs, the page will redirect to APIError.cfm to 
show exact error details

*************************************************
-->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<head>
    <title>PayPal SDK - Transaction Search Results</title>
    <link href="sdk.css" rel="stylesheet" type="text/css" />
</head>
<body>
    <center>
   <cfset StructClear(Session)>
   <CFSET requestData = StructNew()>
<CFOBJECT COMPONENT="CallerService" NAME="caller">
    <cfset fromDate = #DateFormat(#Form.startDate#, "mm-dd-yyyy")#>
    <cfset month = #month(fromDate)#>
    <cfset day = #day(fromDate)#>
    <cfset year = #year(fromDate)#>
    <cfset paypalfrmDate = year &"-"& month &"-"& day & "T00:00:00Z">
    <cfif #Form.endDate# IS NOT "">
	    <cfset toDate = #DateFormat(#Form.endDate#, "mm-dd-yyyy")#>
	    <cfset month = #month(toDate)#>
	    <cfset day = #day(toDate)#>
	    <cfset year = #year(toDate)#>
	    <CFSET requestData.ENDDATE = year &"-"& month &"-"& day & "T23:00:00Z">
    </cfif>
    <cfset transactionID = "#Form.transactionID#">
    <CFTRY>

<CFSET requestData.METHOD = "TransactionSearch">
<CFSET requestData.USER = "#APIUserName#">
<CFSET requestData.PWD = "#APIPassword#">
<CFSET requestData.SIGNATURE = "#APISignature#">
<CFSET requestData.VERSION = "#version#">
<CFSET requestData.STARTDATE = "#paypalfrmDate#">
<CFIF #Form.transactionID# IS NOT "">
<CFSET requestData.TRANSACTIONID = "#Form.transactionID#">
</CFIF>

<!--- 
	Calling doHttppost for API call 
--->

<cfinvoke component="CallerService" method="doHttppost" returnvariable="response">

	<cfinvokeargument name="requestData" value=#requestData#>
	<cfinvokeargument name="serverURL" value=#serverURL#>
	<cfinvokeargument name="proxyName" value=#proxyName#>
	<cfinvokeargument name="proxyPort" value=#proxyPort#>
	<cfinvokeargument name="useProxy" value=#useProxy#>

</cfinvoke>

<CFSET responseStruct = caller.getNVPResponse(#URLDecode(response)#)>
 <CFSET messages = ArrayNew(1)>
 <CFSET Session.resStruct ="#responseStruct#">
 <CFSET txnCount = 0>
 <CFLOOP collection=#responseStruct# item="key">
	<CFIF StructKeyExists(responseStruct, "L_TRANSACTIONID" & #txnCount#)>
		<CFSET #txnCount# = txnCount + 1>
	</CFIF>
</CFLOOP>
 <CFIF responseStruct.Ack is "Success" and txnCount is not 0>
    <table class="api">
        <tr>
            <td colspan="6" class="header">
                Transaction Search Results 1 - <CFOUTPUT>#txnCount#</CFOUTPUT>
            </td>
        </tr>
	<tr>
            <td class="field">
            </td>
            <td class="field">
                ID</td>
            <td class="field">
                Time</td>
            <td class="field">
                Status</td>
            <td class="field">
                Payer Name</td>
            <td class="field">
                Gross Amount</td>
        </tr>
 <CFSET txnCount = 0>
 <CFSET	txnSearchTable = StructNew()>
 <CFSET rowCount =  0>
<CFLOOP collection=#responseStruct# item="key">

	<CFIF StructKeyExists(responseStruct, "L_TRANSACTIONID" & #txnCount#)>
	 <CFSET rowCount =  rowCount + 1>
	<tr>

		<CFSET txnKey = "L_TRANSACTIONID" & #txnCount#>
		<CFSET timeStmpKey = "L_TIMESTAMP" & #txnCount#>
		<CFSET statusKey = "L_STATUS" & #txnCount#>
		<CFSET nameKey  = "L_NAME" & #txnCount#>
		<CFSET amtKey = "L_AMT" & #txnCount#>
		<td><CFOUTPUT>#rowCount#</CFOUTPUT></td>
		<td><a href="TransactionDetails.cfm?transactionID=<CFOUTPUT>#responseStruct[txnKey]#</CFOUTPUT>"><CFOUTPUT>#responseStruct[txnKey]#</CFOUTPUT></a></td>
		<td><CFOUTPUT>#responseStruct[timeStmpKey]#</CFOUTPUT></td>
		<td><CFOUTPUT>#responseStruct[statusKey]#</CFOUTPUT></td>
		<td><CFOUTPUT>#responseStruct[nameKey]#</CFOUTPUT></td>
		<td><CFOUTPUT>#responseStruct[amtKey]#</CFOUTPUT></td>
        </tr>
</CFIF>
<CFSET #txnCount# = txnCount + 1>

</CFLOOP>

</CFIF>

    </table>
<CFIF txnCount is 0>
	<br>Found 0 transactions

</CFIF>
<CFIF responseStruct.Ack is "Failure" or responseStruct.Ack is "SuccessWithWarning">
    <CFLOCATION URL="APIError.cfm?error=fromServer">
</CFIF>
    <CFCATCH>
	<CFSET responseStruct = StructNew() >
	<CFSET responseStruct.errorType =  "#cfcatch.type#">
	<CFSET responseStruct.errorMessage =  "#cfcatch.message#">
	<CFSET Session.resStruct = "#responseStruct#">
	<CFLOCATION URL="APIError.cfm?error=fromClient">

</CFCATCH>
</CFTRY>
    </center>
   <a class="home" id="CallsLink" href="index.html">Home</a>
</body>
</html>