<!--- 
UPSRateMonger 5.01.  Original ColdFusion code Copyright 2000-2004, MSB Designs, Inc.
Use and distribute freely.  No warranties express or implied. 
--->

<!--- 
Documentation for this tag is found in docs.cfm. 
--->
<cfsetting enablecfoutputonly="Yes">
<!--- 
Accept database username and password as incoming parameters; then convert them 
to request vars so we don't have to pass them around to the sub-tags
 --->
<cfparam name="attributes.UPSRPWD" default="" type="string">
<cfparam name="attributes.UPSRUName" default="" type="string">
<cfparam name="request.UPSRPWD" default="attributes.UPSRPWD" type="string">
<cfparam name="request.UPSRUName" default="attributes.UPSRUName" type="string">
<cfset UPS_Success="YES">
<!--- 
Set up the basic parameters.  All attributes scope can be fed in via the tag call 
--->
<cfparam name="attributes.Origin" default="WEST" TYPE="string">
<cfparam name="attributes.AutoXArea" default="Y" TYPE="string">
<cfparam name="attributes.CanadaZone" default="UPS_CanadaZones" TYPE="string">
<cfparam name="attributes.USZone" default="UPSZones" TYPE="string">
<cfparam name="attributes.ResRates" default="YES" TYPE="string">
<cfparam name="variables.Zip3" default="" TYPE="string">
<cfparam name="attributes.ZoneDSN" default="#attributes.SiteDSN#" TYPE="string">
<cfif not IsDefined ("attributes.SiteDSN")>
	<cfset UPS_Success="NO">
	<cfset UPS_Error="The SiteDSN parameter is required, but was not found.  Check your call to this tag (UPSRateMonger.cfm)">
<cfelse>
	<cfif not isdefined ("attributes.ZoneDSN")><cfset attributes.ZoneDSN=attributes.SiteDSN></cfif>
</cfif>
<!--- 
pull the default charges.  The cache time is the decimal/day equivalent of about 10 minutes. 
These will not override any hardcoded attributes.
--->
<cfquery 
	datasource="#attributes.SiteDSN#" 
	name="GetDefaults" 
	username="#request.UPSRUName#" 
	password="#request.UPSRPWD#"
	cachedwithin="0.00695">
	SELECT 
		ups_defaultcharges.FuelCharge,
		ups_defaultcharges.NDAResCharge,
		ups_defaultcharges.NDAResDASCharge,
		ups_defaultcharges.NDAComDASCharge,
		ups_defaultcharges.NDAEAMCharge,
		ups_defaultcharges.TwoDayAMDASCharge,
		ups_defaultcharges.TwoDayResCharge,
		ups_defaultcharges.TwoDayResDASCharge,
		ups_defaultcharges.TwoDayComDASCharge,
		ups_defaultcharges.ThreeDayResCharge,
		ups_defaultcharges.ThreeDayResDASCharge,
		ups_defaultcharges.ThreeDayComDASCharge,
		ups_defaultcharges.GNDResDASCharge,
		ups_defaultcharges.GndComDASCharge,
		ups_defaultcharges.ExpressPlus,
		ups_defaultcharges.WW_EAS_Rate,
		ups_defaultcharges.WW_EAS_Min
	FROM ups_defaultcharges
	WHERE 
		0=0
</cfquery>
<!--- 
Set the default charges to work in the attributes scope, 
so they can all be specified in the tag call. 
--->
<cfparam name="attributes.FuelCharge" DEFAULT="#GetDefaults.FuelCharge#" TYPE="numeric">
<cfparam name="attributes.NDAResCharge" DEFAULT="#GetDefaults.NDAResCharge#" TYPE="numeric">
<cfparam name="attributes.NDAComDASCharge" DEFAULT="#GetDefaults.NDAComDASCharge#" TYPE="numeric">
<cfparam name="attributes.NDAResDASCharge" DEFAULT="#GetDefaults.NDAResDASCharge#" TYPE="numeric">
<cfparam name="attributes.NDAEAMCharge" DEFAULT="#GetDefaults.NDAEAMCharge#" TYPE="numeric">
<cfparam name="attributes.TwoDayAMDASCharge" DEFAULT="#GetDefaults.TwoDayAMDASCharge#" TYPE="numeric">
<cfparam name="attributes.TwoDayResCharge" DEFAULT="#GetDefaults.TwoDayResCharge#" TYPE="numeric">
<cfparam name="attributes.TwoDayResDASCharge" DEFAULT="#GetDefaults.TwoDayResDASCharge#" TYPE="numeric">
<cfparam name="attributes.TwoDayComDASCharge" DEFAULT="#GetDefaults.TwoDayComDASCharge#" TYPE="numeric">
<cfparam name="attributes.ThreeDayResCharge" DEFAULT="#GetDefaults.ThreeDayResCharge#" TYPE="numeric">
<cfparam name="attributes.ThreeDayResDASCharge" DEFAULT="#GetDefaults.ThreeDayResDASCharge#" TYPE="numeric">
<cfparam name="attributes.ThreeDayComDASCharge" DEFAULT="#GetDefaults.ThreeDayComDASCharge#" TYPE="numeric">
<cfparam name="attributes.GndResDASCharge" DEFAULT="#GetDefaults.GndResDASCharge#" TYPE="numeric">
<cfparam name="attributes.GndComDASCharge" DEFAULT="#GetDefaults.GndComDASCharge#" TYPE="numeric">
<cfparam name="attributes.ExpressPlus" DEFAULT="#GetDefaults.ExpressPlus#" TYPE="numeric">
<cfparam name="attributes.WW_EAS_Rate" DEFAULT="#GetDefaults.WW_EAS_Rate#" TYPE="numeric">
<cfparam name="attributes.WW_EAS_Min" DEFAULT="#GetDefaults.WW_EAS_Min#" TYPE="numeric">
<!--- 
Is the country parameter present? 
--->
<cfif IsDefined ("attributes.Country")>
	<cfif not CompareNoCase(attributes.Country,"Canada") OR not CompareNoCase(attributes.Country,"USA")>
		<cfif not isdefined ("attributes.PostalCode")>
			<cfset UPS_Error="The postal/ZIP code was not specified, and is required.  Please check your entry and try again.">
			<cfset UPS_Success="NO">
		<cfelse>
			<cfset variables.Zip3=#LEFT(attributes.PostalCode,3)#>
			<cfswitch expression="#attributes.Country#">
				<cfcase value="USA">
					<cfif not #IsNumeric(variables.Zip3)#>
						<cfset UPS_Error="The postal code you listed doesn't appear to be valid.  Please check your entry and try again.">
						<cfset UPS_Success="NO">
					</cfif>					
				</cfcase>
				<cfcase value="Canada">
					<cfset variables.PassFail=0>
					<cfif not isnumeric(left(variables.Zip3,1))><cfset variables.PassFail=variables.PassFail+1></cfif>
					<cfif isnumeric(mid(variables.Zip3,2,1))><cfset variables.PassFail=variables.PassFail+1></cfif>
					<cfif not isnumeric(right(variables.Zip3,1))><cfset variables.PassFail=variables.PassFail+1></cfif>
					<cfif variables.PassFail LT 3>
						<cfset UPS_Error="The postal code you listed doesn't appear to be valid.  Please check your entry and try again.">
						<cfset UPS_Success="NO">
					</cfif>				
				</cfcase>
			</cfswitch>
		</cfif>
	</cfif>		
<cfelse>
	<cfset UPS_Success="NO">
	<cfset UPS_Error="The Country parameter is required, but was not found.  Check your call to this tag (UPSRateMonger.cfm)">
</cfif>
<!--- 
So far so good.  Now check the validity of the shipping weight parameter 
--->
<cfif IsDefined ("attributes.ShipWeight")>
	<cfif #IsNumeric(attributes.ShipWeight)#>
		<!--- 
		Yes, the shipping weight is numeric.  Now round up the weight if 
		a fraction was entered. This is consistent with UPS online rating practices. 
		--->
		<cfset attributes.ShipWeight=#Ceiling(attributes.ShipWeight)#>
	<cfelse>
		<!--- 
		The shipping weight was entered, but it isn't a strictly numeric value 
		--->
		<cfset UPS_Error="The shipping weight must be numeric.  Check your call to this tag (UPSRateMonger.cfm)">
		<cfset UPS_Success="NO">
	</cfif>
<cfelse>
	<cfset UPS_Error="The ShipWeight parameter is required, but was not found.  You probably forgot to specify it.  Check your call to this tag (UPSRateMonger.cfm)">
	<cfset UPS_Success="NO">
</cfif>
<!---
Was the shipping service type passed in?
--->
<cfif not IsDefined ("attributes.ServiceType")>
	<!--- 
	The ServiceType parameter doesn't exist.  Set the error flag and message 
	--->
	<cfset UPS_Error="The ServiceType input parameter was not found.  You probably forgot to specify it.  Check your call to this tag (UPSRateMonger.cfm).">
	<cfset UPS_Success="NO">
</cfif>
<!--- 
OK.  It exists.  Is it an acceptable value? 
--->
<cfif not CompareNoCase(UPS_Success,"YES")>
	<cfswitch expression="#attributes.ServiceType#">
		<cfcase value="CANSTD">
			<!--- 
			Canadian plan selected.  Was Canada the selected destination country? 
			--->
			<cfif CompareNoCase(attributes.Country,"Canada")>
				<cfset UPS_Error="You picked a shipping plan only valid for Canada, but picked a different destination country.  Please try again.">
				<cfset UPS_Success="NO">
			</cfif>
			<!--- 
			Canada was selected.  Run the Canada Standard tag. 
			--->
			<cfif not CompareNoCase(UPS_Success,"YES")>
				<!--- 
				call UPS_Canada to calc the rates
				--->
				<CF_UPS_Canada 
					PostalCode=#attributes.PostalCode# 
					ShipWeight=#attributes.ShipWeight# 
					ServiceType=#attributes.ServiceType# 
					SiteDSN=#attributes.SiteDSN#
					ZoneDSN=#attributes.ZoneDSN#
					CanadaZone=#attributes.CanadaZone#
					Zip3=#variables.Zip3#>
				<!---
				Done. Now pass the variables back to the parent template
				--->
				<!--- 
				calc'd rate variables 
				--->
				<cfset caller.UPS_Name=#UPS_Name#>
				<cfset caller.UPS_Charge=#UPS_Charge#>
				<cfset caller.UPS_Error=#UPS_Error#>
				<cfset caller.UPS_Success=#UPS_Success#>
				<!--- 
				user input variables 
				--->
				<cfset caller.PostCode=attributes.PostalCode>
				<cfset caller.Shipwt=attributes.ShipWeight>
				<cfset caller.ShipType=attributes.ServiceType>
				<cfset caller.Country=attributes.Country>
			</cfif>
		</cfcase>
		<cfcase value="1DAEAM,1DA,1DP,2DM,2DA,3D,3DSC,3DSR,GNDCOM,GNDRES">
			<!--- 
			Its one of the acceptable values.  Now lets test the 
			destination, and then the postal code.
			--->
			<cfif CompareNoCase(attributes.Country,"USA")>
				<cfset UPS_Error="You picked a shipping plan only valid for the U.S., but picked a different destination country.  Please try again.">
				<cfset UPS_Success="NO">
			</cfif>
			<cfif not CompareNoCase(UPS_Success,"YES")>
				<CF_UPS_USA 
					PostalCode=#attributes.PostalCode# 
					ShipWeight=#attributes.ShipWeight# 
					ServiceType=#attributes.ServiceType# 
					SiteDSN=#attributes.SiteDSN#
					ZoneDSN=#attributes.ZoneDSN#
					USZone=#attributes.USZone#
					Zip3=#variables.Zip3#
					ResRates=#attributes.ResRates#
					NDAResCharge=#attributes.NDAResCharge#
					NDAResDASCharge=#attributes.NDAResDASCharge#
					NDAComDASCharge=#attributes.NDAComDASCharge#
					NDAEAMCharge=#attributes.NDAEAMCharge#
					TwoDayAMDASCharge=#attributes.TwoDayAMDASCharge#
					TwoDayResCharge=#attributes.TwoDayResCharge#
					TwoDayResDASCharge=#attributes.TwoDayResDASCharge#
					TwoDayComDASCharge=#attributes.TwoDayComDASCharge#
					ThreeDayResCharge=#attributes.ThreeDayResCharge#
					ThreeDayResDASCharge=#attributes.ThreeDayResDASCharge#
					ThreeDayComDASCharge=#attributes.ThreeDayComDASCharge#
					GndResDASCharge=#attributes.GndResDASCharge#
					GndComDASCharge=#attributes.GndComDASCharge#>
				<!---
				Done. Now pass the variables back to the parent template
				--->
				<!--- 
				calc'd rate variables 
				--->
				<cfset caller.UPS_Name=#UPS_Name#>
				<cfset caller.UPS_Charge=#UPS_Charge#>
				<cfset caller.UPS_Error=#UPS_Error#>
				<cfset caller.UPS_Success=#UPS_Success#>
				<!--- 
				user input variables 
				--->
				<cfset caller.PostCode=attributes.PostalCode>
				<cfset caller.Shipwt=attributes.ShipWeight>
				<cfset caller.ShipType=attributes.ServiceType>
				<cfset caller.Country=attributes.Country>
			</cfif>
		</cfcase>
		<cfcase value="WWXPR,WWXPRP,WWXPD">
			<cfif not CompareNoCase(attributes.Country,"USA")>
				<cfset UPS_Error="You picked an international shipping plan, but chose a domestic U.S. destination.  Try again with a domestic shipping plan.">
				<cfset UPS_Success="NO">
			</cfif>
			<!--- 
			If you are not using AutoXArea=Y, be sure your 
			entry form design accounts for this.  See the files with 
			names prefixed ''runme'' for how to call these plans with 
			AutoXArea set to 'N'
			--->
			<cfif not CompareNoCase(attributes.AutoXArea,"Y")>
				<cfparam name="attributes.Xarea" default="Yes" TYPE="string">
				<!--- 
				Grab the zone data for the country we are dealing with based on user entry.
				--->
				<CF_UPS_WW		
					Country=#attributes.Country#
					Xarea=#attributes.Xarea# 
					ShipWeight=#attributes.ShipWeight# 
					ServiceType=#attributes.ServiceType# 
					Origin=#attributes.Origin#
					SiteDSN=#attributes.SiteDSN#
					Zip3=#variables.Zip3#
					ExPlusCharge=#attributes.ExpressPlus#
					WW_EAS_Rate=#attributes.WW_EAS_Rate#
					WW_EAS_Min=#attributes.WW_EAS_Min#
					ResRates=#attributes.ResRates#>
			</cfif>
			<!---
			Done. Now pass the variables back to the parent template
			--->
			<!--- 
			calc'd rate variables 
			--->
			<cfset caller.UPS_Name=#UPS_Name#>
			<cfset caller.UPS_Charge=#UPS_Charge#>
			<cfset caller.UPS_Error=#UPS_Error#>
			<cfset caller.UPS_Success=#UPS_Success#>
			<!--- 
			user input variables 
			--->
			<cfset caller.Shipwt=attributes.ShipWeight>
			<cfset caller.ShipType=attributes.ServiceType>
			<cfset caller.Country=attributes.Country>
		</cfcase>
		<cfdefaultcase>
			<!--- 
			No, its not an acceptable value.  Set the error flag and message 
			--->
			<cfset UPS_Error="The ServiceType input parameter was found but is not an existing service option.  You probably mispelled the input variable. Check your call to this tag (UPSRateMonger.cfm).">
			<cfset UPS_Success="NO">
		</cfdefaultcase>
	</cfswitch>
</cfif>
<!--- 
calculate and insert the fuel surcharge 
--->
<cfif not CompareNoCase(UPS_Success,"NO")>
	<!--- 
	UNcalc'd rate variables 
	--->
	<cfset caller.UPS_name="ERROR!">
	<cfset caller.UPS_Charge=0>
	<cfset caller.UPS_Error=#UPS_Error#>
	<cfset caller.UPS_Success=#UPS_Success#>
	<!--- 
	user input variables 
	--->
	<cfset caller.PostCode=0>
	<cfset caller.Shipwt=0>
	<cfset caller.ShipType="ERROR">
<cfelse>
	<cfswitch expression="#attributes.ServiceType#">
		<cfcase value="GNDCOM,GNDRES,CANSTD">
			<!--- 
			fuel surcharge has been discontinued for 2004 on these plans
			--->
			<cfset caller.UPS_Charge=UPS_Charge>
		</cfcase>
		<cfdefaultcase>
			<!--- 
			assess the fuel surcharge 
			--->
			<cfset caller.UPS_Charge=(UPS_Charge*attributes.FuelCharge)+UPS_Charge>
		</cfdefaultcase>
	</cfswitch>
</cfif>
<cfsetting enablecfoutputonly="NO">