<!--- 
Grab the appropriate weight record
--->
<cfquery 
	datasource="#attributes.SiteDSN#" 
	name="RateGrab" 
	maxrows="1"
	username="#request.UPSRUName#" 
	password="#request.UPSRPWD#">
	SELECT
		ups_ww_xpr.Weight,
		ups_ww_xpr.Zone80,
		ups_ww_xpr.Zone81,
		ups_ww_xpr.Zone82,
		ups_ww_xpr.Zone84,
		ups_ww_xpr.Zone900,
		ups_ww_xpr.Zone901,
		ups_ww_xpr.Zone902,
		ups_ww_xpr.Zone903,
		ups_ww_xpr.Zone904,
		ups_ww_xpr.Zone905,
		ups_ww_xpr.Zone906,
		ups_ww_xpr.Zone907,
		ups_ww_xpr.Zone908
	FROM ups_ww_xpr
	WHERE 
		ups_ww_xpr.Weight<=
		<cfqueryparam cfsqltype="CF_SQL_NUMERIC" value="#attributes.ShipWeight#">
	ORDER BY 
	ups_ww_xpr.Weight DESC
</cfquery>
<!--- 
Now that we have the weight record, apply the appropriate zone charge.  
If the zone isn't found, return an error. 
--->
<!--- 
We have to run either standard rate calcs, or those for Dade/Broward depending 
on the Origin parameter.  All of the zones in the table are accounted for here even 
though Zones 80 and 84 are unique to each origin set.
--->
<cfif CompareNoCase(attributes.Origin,"DADE")>
	<cfswitch expression="#ZoneGrab.WWXPR#">
		<cfcase value="80"><cfset caller.ups_Charge=RateGrab.Zone80></cfcase>
		<cfcase value="81"><cfset caller.ups_Charge=RateGrab.Zone81></cfcase>
		<cfcase value="82"><cfset caller.ups_Charge=RateGrab.Zone82></cfcase>
		<cfcase value="84"><cfset caller.ups_Charge=RateGrab.Zone84></cfcase>
		<cfcase value="900"><cfset caller.ups_Charge=RateGrab.Zone900></cfcase>
		<cfcase value="901"><cfset caller.ups_Charge=RateGrab.Zone901></cfcase>
		<cfcase value="902"><cfset caller.ups_Charge=RateGrab.Zone902></cfcase>
		<cfcase value="903"><cfset caller.ups_Charge=RateGrab.Zone903></cfcase>
		<cfcase value="904"><cfset caller.ups_Charge=RateGrab.Zone904></cfcase>
		<cfcase value="905"><cfset caller.ups_Charge=RateGrab.Zone905></cfcase>
		<cfcase value="906"><cfset caller.ups_Charge=RateGrab.Zone906></cfcase>
		<cfcase value="907"><cfset caller.ups_Charge=RateGrab.Zone907></cfcase>
		<cfcase value="908"><cfset caller.ups_Charge=RateGrab.Zone908></cfcase>
		<cfdefaultcase>
			<cfset caller.ups_Error="That service is unavailable in the destination area (Zone record not found). Please try a different plan">
		</cfdefaultcase>
	</cfswitch>
<cfelse>
	<cfswitch expression="#ZoneGrab.WWXPRDade#">
		<cfcase value="80"><cfset caller.ups_Charge=RateGrab.Zone80></cfcase>
		<cfcase value="81"><cfset caller.ups_Charge=RateGrab.Zone81></cfcase>
		<cfcase value="82"><cfset caller.ups_Charge=RateGrab.Zone82></cfcase>
		<cfcase value="84"><cfset caller.ups_Charge=RateGrab.Zone84></cfcase>
		<cfcase value="900"><cfset caller.ups_Charge=RateGrab.Zone900></cfcase>
		<cfcase value="901"><cfset caller.ups_Charge=RateGrab.Zone901></cfcase>
		<cfcase value="902"><cfset caller.ups_Charge=RateGrab.Zone902></cfcase>
		<cfcase value="903"><cfset caller.ups_Charge=RateGrab.Zone903></cfcase>
		<cfcase value="904"><cfset caller.ups_Charge=RateGrab.Zone904></cfcase>
		<cfcase value="905"><cfset caller.ups_Charge=RateGrab.Zone905></cfcase>
		<cfcase value="906"><cfset caller.ups_Charge=RateGrab.Zone906></cfcase>
		<cfcase value="907"><cfset caller.ups_Charge=RateGrab.Zone907></cfcase>
		<cfcase value="908"><cfset caller.ups_Charge=RateGrab.Zone908></cfcase>
		<cfdefaultcase>
			<cfset caller.ups_Error="That service is unavailable in the destination area (Zone record not found). Please try a different plan">
		</cfdefaultcase>
	</cfswitch>
</cfif>

